/* CHCP Proxy by Vasim V. */

#define IGNORE_ERROR /* ignore errors at receive and send data */

#define INCL_DOSPROCESS
#include <os2.h>
#ifndef GCC_VERSION
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <netinet\in.h>
#include <sys\socket.h>
#include <netdb.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <time.h>
#include <regexp.h>
#include <stdarg.h>
#include <process.h>

#define BUFFER_SIZE 3072
#define MAX_INPUT_SOCKETS 512
#define MAX_MIME_HEADER_SIZE 2048

/* Regular expressions for regcomp , regexec and regsub */
/* see 'man regexp' for details */
#define CONTENT_TYPE_FLAG "[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]"
#define CHARSET_FLAG "; *[Cc][Hh][Aa][Rr][Ss][Ee][Tt]=[ !#-&(-\x7f]*"
#define TEXT_FLAG "[Tt][Ee][Xx][Tt] */[\x20-\x7f]*"
#define SPACE "[ \\\r\\\n\\\t]*"
#define CRLF "[\\\r\\\n]"
char *table_exp[5] = {"[Kk][Oo][Ii][- ]?8[- ]?.?", \
	"(([Cc][Pp])|(([Ww][Ii][Nn])([Dd][Oo][Ww][Ss]?)?)|([Aa][Nn][Ss][Ii]))[- ]?1251", \
	"[Ii][Ss][Oo]-?8859-?5", \
	"YOUR", \
	"[Cc][Pp][- ]?866"};
regexp *etable[5];

/* for HTTP-header */
#define CONTENT_TEXT_FLAG CRLF CONTENT_TYPE_FLAG ": *" TEXT_FLAG CRLF
regexp *econtent;
#define MIME_TEXT_FLAG CRLF CONTENT_TYPE_FLAG ": *" TEXT_FLAG CHARSET_FLAG CRLF
regexp *emime;
#define CHARSET_SUBSTRING CHARSET_FLAG
regexp *echarset;

/* for htmls from Microsoft FrontPage . *WHY* ?!?!?!?!? :~~~( */
#define META_FLAG "<" SPACE "[Mm][Ee][Tt][Aa]" SPACE \
	"[Hh][Tt][Tt][Pp]-[Ee][Qq][Uu][Ii][Vv]" SPACE \
	"=" SPACE "[\"\']" CONTENT_TYPE_FLAG "[\"\']" SPACE \
	"[Cc][Oo][Nn][Tt][Ee][Nn][Tt]" SPACE "=" SPACE \
	"[\"\']" TEXT_FLAG CHARSET_FLAG "[\"\']" SPACE ">"
regexp *emeta;

/* Names of charsets for replace in headers */
char *table_name[5] = {"koi8-r","windows-1251","iso-8859-5","your","cp866"};

char *flrep_name[4] = {"Pass w/o changes","Cut all","Replace charset", \
	"Cut only \'; charset=xxx\'"};
char *flpri_name[5] = {"Ignore headers","Look in MIME-header only", \
	"Look in META only","Look in MIME-header then META", \
	"Look in META then MIME-header"};

typedef struct {
 	int proxy_sock;
	int in_sock;
	int table; } sockets ;

#ifdef WATCOM_VERSION
#define _Optlink
#endif

void _Optlink new_request (void *num_socket);
void _Optlink to_proxy_thread (void *num_sockets);
void _Optlink menu (void *null_param);
int  send_translate (int sock , char *buf, int size ,int flag_translate ,int table);
void hex_translate (char *buf , int flag_translate , int table);
void fill_tables_translation ();
void load_table (int table,char *filename);
void log (const char *fmt , ...);

FILE *logerr;
int number_sockets ;
int flag_exit ;
int translate_from_page ;
int translate_to_page ;
int flag_all_translate;		/* 1 - translate all , 0 - only text */
int flag_hex_translate;		/* 1 - translate hex codes , 0 - ignore hex */
int flag_replace_mime;		/* 0 - Cut (Very bad idea !!!) , 1 - Replace ,
				*  2 - Cut '; charset = xxx' substring, -1 - No action
				*/
int flag_replace_meta;		/* 0 - Cut (Very bad idea !!!) , 1 - Replace ,
				*  2 - Cut '; charset = xxx' substring, -1 - No action
				*/
int flag_charset_priority;	/* 0 - don't use any headers (use default charset)
				* 1 - use charset from mime-header only ,
				* 2 - use charset from meta only ,
				* 3 - use charset from meta and mime-header
				*  (mime-header is priority)
				* 4 - use charset from met and mime-header
				*  (meta is priority)
				*/
char table_to[5][256];
char table_from[5][256];
unsigned long proxy_address ;
unsigned short proxy_port ;
char tbcp[4][224] ;
int sock;

#ifdef GCC_VERSION
#define strcmpi(x,y) stricmp(x,y)
#define sock_init()
#define soclose(x) close(x)
#define psock_errno perror
#endif

void regerror (char *str)
{
    fprintf(stderr,"%s\r\n",str);
    exit (1);
}

main (int argc ,char **argv)
{
 unsigned short port ;
 struct sockaddr_in server , client ;
 char *proxy_addr ;
 struct hostent *host_proxy;
 int res , slen ;
 int rc ;
 int i;

 flag_exit = 0;
 sock_init ();

 if ((argc<7) || (argc>12))
 {
	fprintf(stderr, "Usage: %s port proxy proxy_port from_codepage to_codepage flag_all_translate flag_hex_translate flag_header_priority flag_replace_mime flag_replace_meta logfile_name\r\n", argv[0]);
	exit(1);
 }

 if (!(emeta = regcomp(META_FLAG)))
	regerror ("error in META_FLAG");
 if (!(emime = regcomp(MIME_TEXT_FLAG)))
	regerror ("error in MIME_TEXT_FLAG");
 if (!(econtent = regcomp(CONTENT_TEXT_FLAG)))
	regerror ("error in CONTENT_TEXT_FLAG");
 if (!(echarset = regcomp(CHARSET_SUBSTRING)))
 	regerror ("error in CHARSET_SUBSTRING");
 for (i=0 ; i<5 ; i++)
	if (!(etable[i]=regcomp(table_exp[i])))
		regerror ("error in table_exp");

 port = (unsigned short) atoi(argv[1]) ;
 proxy_port = (unsigned short) atoi(argv[3]) ;
 proxy_addr = argv[2] ;
 translate_from_page = table_number(atoi(argv[4]));
 translate_to_page = table_number(atoi(argv[5]));
 flag_all_translate = (atoi(argv[6])!=0);
 if (argc>7) flag_hex_translate = (atoi(argv[7])!=0);
	else flag_hex_translate = !flag_all_translate;
 if (argc<9) flag_charset_priority = 4;
	else flag_charset_priority = atoi(argv[8]);
 if (argc<10) flag_replace_mime = 2;
	else flag_replace_mime = atoi(argv[9]);
 if (argc<11) flag_replace_meta = 0;
	else flag_replace_meta = atoi(argv[10]);
 if (argc<12) logerr = stderr ;
 	else
	{
		logerr = fopen (argv[11],"a");
		if (logerr == NULL)
		{
			fprintf(stderr,"Can't open log-file\r\n");
			exit(1);
		}
	}

 load_table(0,"koi_866.cdp");
 load_table(1,"win_866.cdp");
 load_table(2,"iso_866.cdp");
 load_table(3,"tmp_866.cdp");

 if (!strcmpi(proxy_addr , "localhost")) proxy_address = (1*256*256*256) + 127 ;
 else
 {

	if ((proxy_addr[0] >= '0') && (proxy_addr[0] <= '9'))
		proxy_address = inet_addr(proxy_addr);
	else
	{
	 	host_proxy = gethostbyname(proxy_addr);
		if (host_proxy==NULL)
		{
			fprintf(stderr,"Proxy address %s is unknown\r\n",proxy_addr);
			exit(2);
		} else proxy_address = *((unsigned long *) host_proxy->h_addr);
	}
 }

 sock = socket(AF_INET,SOCK_STREAM,0);
 if (sock<0)
 {
	psock_errno("Create main socket");
	exit(3);
 }
 server.sin_family = AF_INET;
 server.sin_port = htons(port);
 server.sin_addr.s_addr = INADDR_ANY;

 res = bind (sock ,(struct sockaddr *)&server , sizeof(server));
 if (res<0)
 {
	psock_errno ("Bind main socket");
	exit(3);
 }

 res = listen(sock,3);
 if (res!=0)
 {
	psock_errno ("Listen main socket");
	exit(3);
 }

 number_sockets = 0;
 fill_tables_translation();
 rc = _beginthread(&menu,NULL,16384,NULL);
 if (rc==-1)
 {
	log("_beginthread error (at run menu thread).");
	exit (5);
 }

 do {
	slen = sizeof (client) ;
	res = accept (sock,(struct sockaddr *)&client , &slen);
	if (res>=0)
	{
		if ((number_sockets+1)>MAX_INPUT_SOCKETS)
		{
			log("Too many thread . New request rejected .");
			soclose(res);
		} else
		{
			log("New socket %d from client with address %s .",res,
				inet_ntoa (client.sin_addr));
			rc = _beginthread(&new_request,NULL,16384,(void *)res);
			if (rc==-1)
			{
				log("_beginthread error (at run new_request thread .");
				exit (5);
			}
		}
	}
 } while (!flag_exit) ;
 log("Exit .");
 fclose(logerr);
 free(emeta);
 free(emime);
 free(econtent);
 free(echarset);
 for (i=0 ; i<5 ; i++) free(etable[i]);
 DosSleep(100);
 exit(0);
};

int bufcut (char *buf,int sizebuf,int offset,int size)
{
	if (size==0) return sizebuf;
	memmove(buf+offset,buf+offset+size,sizebuf-offset-size);
	buf[sizebuf-size]='\0';
	return (sizebuf-size);
}

int bufreplace (char *buf,int sizebuf,int offset,int size,char *replace)
{
	int len;

	len = strlen(replace);
	if (len>size)
	{
		memmove(buf+offset+len,buf+offset+size,sizebuf-offset-size);
		memcpy(buf+offset,(void *)replace,len);
		buf[sizebuf+len-size]='\0';
		return (sizebuf+len-size);
	} else
	{
		memcpy(buf+offset,(void *)replace,len);
		return bufcut(buf,sizebuf,offset+len,size-len);
	}
}

int table_number ( int t)
{
	switch (t)
	{
		case 0 : return 0;
		case 1 : return 3;
		case 866 : return 4;
		case 1251 : return 1;
		case 8859 : return 2;
		default : return 4;
	}
};

void _Optlink menu (void *null_param)
{
 char ch ;
 char *str1, *str2;
 
 do {
	printf ("\x1b[H\x1b[2J\x1b[1;32;40m\t\t\tCHCP Proxy version %s by Vasim V.\x1b[0;37;40m\r\n",VERSION_STRING);
	if (flag_all_translate) str1="(All bytes)"; else str1="(Text only)";
	if (flag_hex_translate) str2="(Hex chars)"; else str2="(No hex)";
	printf ("Current translation : \x1b[1;37;40m%s\x1b[0;37;40m <-> \x1b[1;37;40m%s\x1b[0;37;40m \x1b[1;37;40m%s\x1b[0;37;40m \x1b[1;37;40m%s\x1b[0;37;40m\r\n",
		table_name[translate_from_page],
		table_name[translate_to_page],str1,str2);
	printf ("\tSearch substring \'; charset=xxx\' option : \x1b[1;37;40m%s\x1b[0;37;40m\r\n",flpri_name[flag_charset_priority]);
	printf ("\tCut from MIME-header option : \x1b[1;37;40m%s\x1b[0;37;40m\r\n\tCut from META (with Content-Type) : \x1b[1;37;40m%s\x1b[0;37;40m\r\n",
		flrep_name[1+flag_replace_mime],flrep_name[1+flag_replace_meta]);
	printf ("\x1b[1;36;40m\t\tKeys :\x1b[0;37;40m\r\n\x1b[1;33;40mTranslate from (server's codepage) :\x1b[0;37;40m\r\n");
	printf ("\t\x1b[1;37;42m1\x1b[0;37;40m From KOI-8\r\n\t\x1b[1;37;42m2\x1b[0;37;40m From CP 1251\r\n");
	printf ("\t\x1b[1;37;42m3\x1b[0;37;40m From ISO-8859-5\r\n\t\x1b[1;37;42m4\x1b[0;37;40m From your codepage\r\n");
	printf ("\t\x1b[1;37;42m5\x1b[0;37;40m From CP 866\r\n\x1b[1;33;40mTranslate to (client's codepage) :\x1b[0;37;40m\r\n");
	printf ("\t\x1b[1;37;42m6\x1b[0;37;40m To KOI-8\r\n\t\x1b[1;37;42m7\x1b[0;37;40m To CP 1251\r\n");
	printf ("\t\x1b[1;37;42m8\x1b[0;37;40m To ISO-8859-5\r\n\t\x1b[1;37;42m9\x1b[0;37;40m To your codepage\r\n");
	printf ("\t\x1b[1;37;42m0\x1b[0;37;40m To 866\r\n");
	printf ("\x1b[1;37;42mA\x1b[0;37;40m Translate all\r\n\x1b[1;37;42mH\x1b[0;37;40m Translate hex chars in requests\r\n");
	printf ("\x1b[1;37;42mP\x1b[0;37;40m Change search order for substring \'; charset=xxx\'\r\n");
	printf ("\x1b[1;37;42mT\x1b[0;37;40m Change \'Cut from MIME-header\' option\r\n");
	printf ("\x1b[1;37;42mY\x1b[0;37;40m Change \'Cut from META\' option\r\n");
	printf ("\x1b[1;37;42mE\x1b[0;37;40m Exit program\r\n");
	ch=getch();
	switch (ch)
	{
		case '1' : {
			translate_from_page = 0;
			break; }
		case '2' : {
			translate_from_page = 1;
			break; }
		case '3' : {
			translate_from_page = 2;
			break; }
		case '4' : {
			translate_from_page = 3;
			break; }
		case '5' : {
			translate_from_page = 4;
			break; }
		case '6' : {
			translate_to_page = 0;
			fill_tables_translation ();
			break; }
		case '7' : {
			translate_to_page = 1;
			fill_tables_translation ();
			break; }
		case '8' : {
			translate_to_page = 2;
			fill_tables_translation ();
			break; }
		case '9' : {
			translate_to_page = 3;
			fill_tables_translation ();
			break; }
		case '0' : {
			translate_to_page = 4;
			fill_tables_translation ();
			break; }
		case 'A' :
		case 'a' : { flag_all_translate=!flag_all_translate ; break;}
		case 'H' :
		case 'h' : { flag_hex_translate=!flag_hex_translate ; break;}
		case 'P' :
		case 'p' : { flag_charset_priority = (flag_charset_priority+1) % 5 ; break; }
		case 'T' :
		case 't' :
			{
				flag_replace_mime++;
				if (flag_replace_mime==3) flag_replace_mime=-1;
				if (!flag_replace_mime) flag_replace_mime=1;
				break ;
			}
		case 'Y' :
		case 'y' :
			{
				flag_replace_meta++;
				if (flag_replace_meta==3) flag_replace_meta=-1;
				break ;
			}
		case 'E' :
		case 'e' : { flag_exit = 1; break; }
		default : break ;
	}
 } while (!flag_exit);
 soclose(sock);
 return ;
};

int look_header (char *buf,int *psize,regexp *exp,int flag_replace)
{
	int charset,i,len;
	char *pstart ;
	char *pbegin ;

	if (!regexec (exp,buf)) return -1;
	else
	{
		pbegin = exp->startp[0];
		len = exp->endp[0] - exp->startp[0] ;
		pstart = (char *)malloc (len+1);
		memcpy (pstart , pbegin , len);
		pstart[len] = '\0';
		charset=-1;
		for (i=0 ; i<5 ; i++)
		{
			if (regexec(etable[i],pstart))
			{
				charset = i;
				break ;
			}
		}
		if (flag_replace==0) *psize = bufcut(buf,*psize,
			pbegin-buf,len);
		else if ((flag_replace==1) && (charset>-1)) *psize = bufreplace(buf,*psize,
				etable[charset]->startp[0]-pstart+pbegin-buf,
				etable[charset]->endp[0]-etable[charset]->startp[0],
				table_name[translate_to_page]);
		else if (flag_replace==2)
		{
		    	if (regexec (echarset,pstart))
			    	*psize = bufcut(buf,*psize,
					echarset->startp[0]-pstart+pbegin-buf,
					echarset->endp[0]-echarset->startp[0]);
			else
			    	log("Substring \'; charset=xxx\' not found ... very strange !");
		}
		free (pstart);
		return charset ;
	}
}
	
void _Optlink new_request (void *num_socket)
{
 sockets socks ;
 int rc ;
 char buf[BUFFER_SIZE] ;
 char *temp_buf ;
 char *content_str;
 char *charset_str ;
 char *pos_content ;
 int res, bytes_in, i, length_content ; 
 struct sockaddr_in proxy ;
 int flag_end_thread , flag_translate ;
 int flag_hex_wait , flag_receive_exit ;
 char temp_hex_char ;
 int buf_size ;
 int charset,charset1 ;
 char *pbuf;
 char *find_buf;

 number_sockets++;
 flag_end_thread = 0;
 flag_hex_wait = 0;
 socks.table = translate_from_page ;
 socks.in_sock = (int) num_socket ;
 socks.proxy_sock = socket (AF_INET,SOCK_STREAM,0);
 if (socks.proxy_sock <0 )
 {
	psock_errno("Create proxy socket");
	exit(6);
 }
 proxy.sin_family      = AF_INET;
 proxy.sin_port        = htons(proxy_port);
 proxy.sin_addr.s_addr = proxy_address;
 if (connect(socks.proxy_sock, (struct sockaddr *)&proxy, sizeof(proxy)) < 0)
 {
	psock_errno("Connect to proxy");
#ifndef IGNORE_ERROR
	exit(6);
 }
#else
 } else
 {
#endif
	rc = _beginthread(&to_proxy_thread,NULL,16384,&socks);
	if (rc==-1)
	{
		log("_beginthread error (at run to_proxy_thread) .");
		exit (5);
	}

/* get first MAX_MIME_HEADER_SIZE bytes for detect text/html & text/plain files */
	if (!flag_all_translate)
	{
		bytes_in = 0;
		flag_translate=0;
		do {
			res = recv(socks.proxy_sock,buf+bytes_in,
				MAX_MIME_HEADER_SIZE-bytes_in-1,0);
			if (res < 0) res=0 ;
			bytes_in = bytes_in + res ;
		} while ((bytes_in < MAX_MIME_HEADER_SIZE) && (res != 0)) ;
		buf[bytes_in] = (char)0 ;
		flag_translate = regexec(econtent,buf);
			if (!flag_translate)
				send_translate (socks.in_sock,buf,bytes_in,0,0);
					/* not text file */
			else
			{
				log("Socket %d : Text file detected . Translate is on .",
					socks.in_sock);
	
				charset=look_header(buf,&bytes_in,emime,flag_replace_mime);
				charset1=look_header(buf,&bytes_in,emeta,flag_replace_meta);
				switch (flag_charset_priority)
				{
					case 0 : break ;
					case 1 : { 	if (charset>-1)
							socks.table=charset;
							break; }
					case 2 : { 	if (charset1>-1)
							socks.table=charset1;
							break; }
					case 3 : {
							if (charset>-1) socks.table=charset;
							else if (charset1>-1) socks.table=charset1;
							break; }
					case 4 : {
							if (charset1>-1) socks.table=charset1;
							else if (charset>-1) socks.table=charset;
							break; }
					default : break ;
				}

				buf_size = bytes_in;
				if (flag_hex_translate)
				{
					find_buf = buf;
					while ((find_buf=(char *)memchr(find_buf,(int)'%',buf-find_buf+buf_size))!=NULL)
					{
						if ((buf+buf_size-find_buf)>2) hex_translate(find_buf+1,1,socks.table);
						else
						{
							if ((buf+buf_size-1)==find_buf) flag_hex_wait = 2;
							else
							{
								flag_hex_wait = 1;
								temp_hex_char=find_buf[1];
								buf_size--;
							}
						}
						find_buf++;
					}
				}
				send_translate (socks.in_sock,buf,
					buf_size,1,socks.table);
				log("Socket %d : translate from codepage %s .",
					socks.in_sock,table_name[socks.table]);
			}
	} else flag_translate = 1 ;

/* receive end of file */

	while ((!flag_exit) && (!flag_end_thread)) {
		res = recv(socks.proxy_sock,buf+1,sizeof(buf)-1,0);
		if (res==0) flag_end_thread = 1;
		else if (res<0)
		{
			psock_errno("Receive from proxy");
#ifndef IGNORE_ERROR
			exit(7);
#else
			flag_end_thread = 1;
#endif
		} else
		{
			buf_size = res ;
			pbuf = buf+1 ;
			if (flag_hex_translate && flag_translate)
			{
				if (flag_hex_wait>0)
				{
					if (flag_hex_wait==2)
					{
						if (res==1)
						{
							res = recv(socks.in_sock,pbuf+1,1,0);
							if (res<=0)
							{
								flag_end_thread = 1;
								pbuf[1] = '0' ;
							}
							buf_size++;
						}
					} else
					{
						pbuf-- ;
						pbuf[0] = temp_hex_char;
						buf_size++ ;
					}
					hex_translate(pbuf,flag_translate,socks.table);
					flag_hex_wait = 0;
				}
	
				find_buf = pbuf;
				while ((find_buf=(char *)memchr(find_buf,(int)'%',pbuf-find_buf+buf_size))!=NULL)
				{
					if ((pbuf+buf_size-find_buf)>2) hex_translate(find_buf+1,flag_translate,socks.table);
					else
					{
						if ((pbuf+buf_size-1)==find_buf) flag_hex_wait = 2;
						else
						{
							flag_hex_wait = 1;
							temp_hex_char = find_buf[1];
							buf_size--;
						}
					}
					find_buf++;
				}
			}
			res = send_translate(socks.in_sock,pbuf,buf_size,flag_translate,socks.table);
			if (res <0)
			{
				psock_errno("Send to client");
#ifndef IGNORE_ERROR
				exit(8);
#else
				flag_end_thread = 1;
#endif
			}
		}
	}
 } 
 soclose (socks.proxy_sock);
 soclose (socks.in_sock);
 log("Socket %d closed .", socks.in_sock);
 number_sockets--;
 return ;
};

void _Optlink to_proxy_thread (void *num_sockets)
{
 sockets *socks ;
 char buf[BUFFER_SIZE];
 int res ;
 int flag_hex_wait , flag_receive_exit ;
 char temp_hex_char ;
 int buf_size ;
 char *pbuf;
 char *find_buf;

 socks = (sockets *) num_sockets ;
 flag_hex_wait = 0 ;
 flag_receive_exit = 0;

 do {
	res = recv(socks->in_sock,buf+1,sizeof(buf)-1,0);
	if (res==0) return ;
	else if (res<0)
	{
		return ;
	} else
	{
		buf_size = res ;
		pbuf = buf+1 ;
		if (flag_hex_translate)
		{
			if (flag_hex_wait>0)
			{
				if (flag_hex_wait==2)
				{
					if (res==1)
					{
						res = recv(socks->in_sock,pbuf+1,1,0);
						if (res<=0)
						{
							flag_receive_exit = 1;
							pbuf[1] = '0' ;
						}
						buf_size++;
					}
				} else
				{
					pbuf-- ;
					pbuf[0] = temp_hex_char;
					buf_size++ ;
				}
				hex_translate(pbuf,2,socks->table);
				flag_hex_wait = 0;
			}

			find_buf = pbuf;
			while ((find_buf=(char *)memchr(find_buf,(int)'%',pbuf-find_buf+buf_size))!=NULL)
			{
				if ((pbuf+buf_size-find_buf)>2) hex_translate(find_buf+1,2,socks->table);
				else
				{
					if ((pbuf+buf_size-1)==find_buf) flag_hex_wait = 2;
					else
					{
						flag_hex_wait = 1;
						temp_hex_char = find_buf[1];
						buf_size--;
					}
				}
				find_buf++;
			}
		}

		res = send_translate(socks->proxy_sock,pbuf,buf_size,2,socks->table);
		if (res <0)
		{
			psock_errno("Send to proxy");
#ifndef IGNORE_ERROR
			exit(8);
#else
			return ;
#endif
		}
	}
 } while ((!flag_exit) && (!flag_receive_exit));
};

int send_translate (int sock ,char *buf,int size , int flag_translate , int table)
{
 int i ;

 switch (flag_translate) {
	case 0 : return send (sock , buf, size , 0);
	case 1 : {
			for (i=0;i<size;i++)
				buf[i]=table_from[table][buf[i]];
			return send (sock , buf , size ,0);
		}
	case 2 : {
			for (i=0;i<size;i++)
				buf[i]=table_to[table][buf[i]];
			return send (sock , buf , size ,0);
		}
 }
};

int xc2d(char c)
{
	int temp;

	temp = toupper(c)-'0';
	if (temp>9) return (temp-'A'+'9'+1);
	else return temp;
}

char d2xc(int k)
{
	if (k>9) return (k+'A'-10);
	else return (k+'0');
}

void hex_translate (char *buf , int flag_translate , int table)
{
 char temp ;

 if ((!isxdigit(buf[0])) || (!isxdigit(buf[1]))) return;
 switch (flag_translate) {
	case 0 : return ;
	case 1 : {
			temp = table_from[table][xc2d(buf[0])*16+xc2d(buf[1])];
			break ;
		}
	case 2 : {
			temp = table_to[table][xc2d(buf[0])*16+xc2d(buf[1])];
			break ;
		}
 }
 buf[0]=d2xc(temp/16);
 buf[1]=d2xc(temp%16);
 return;
};


char char_num(int ch , char *table)
{
 int i;

 for (i=0;((i<224) && (*(table+i)!=(char)ch));i++);
 if (i==224) i=ch-32 ;
 return (char)(i+32) ;

};

void fill_tables_translation()
{
 int i , j , flag ;

 for (i=0;i<32;i++)
 {
	table_to[0][i]=(char)i; table_from[0][i]=(char)i;
	table_to[1][i]=(char)i; table_from[1][i]=(char)i;
	table_to[2][i]=(char)i; table_from[2][i]=(char)i;
	table_to[3][i]=(char)i; table_from[3][i]=(char)i;
	table_to[4][i]=(char)i; table_from[4][i]=(char)i;
 }
 for (i=0;i<5;i++)
 {
	memset(table_from[i]+32,32,224);
	memset(table_to[i]+32,32,224);
	for (j=32;j<256;j++)
	{
		if (i==translate_to_page)
		{
			table_from[i][j]=j;
			table_to[i][j]=j;
		} else
		{
			if (i==4)
			{
				table_from[i][j]=char_num(j,tbcp[translate_to_page]);
				table_to[i][j]=tbcp[translate_to_page][j-32];
			} else
			{
				if (translate_to_page==4)
				{
					table_from[i][j]=tbcp[i][j-32];
					table_to[i][j]=char_num(j,tbcp[i]);
				} else
				{
					table_from[i][j]=char_num(tbcp[i][j-32],
						tbcp[translate_to_page]);
					table_to[i][j]=char_num(tbcp[translate_to_page][j-32],
						tbcp[i]);
				}
			}
		}
	}
 }
 return ;
};

void load_table (int table , char *filename)
{
 FILE *f;

 f = fopen(filename,"rb");
 if (f==NULL)
 {
	fprintf (stderr,"Codepage file %s not loaded\r\n",filename);
	exit (1);
 }
 fread (tbcp[table],224,1,f);
 fclose(f);
 return;
};

void log(const char *fmt, ...)
{
    va_list ap;
    time_t ltime;
    struct tm *ntime;

    time(&ltime);
    ntime = localtime(&ltime);
    fprintf(logerr,"%s\t",asctime(ntime));
    va_start(ap,fmt);
    vfprintf(logerr,fmt,ap);
    va_end(ap);
    fprintf(logerr,"\r\n");
    fflush(logerr);
}
